#!/usr/bin/perl
#use FCGI;
#-------------------------------------------------------------------------------------#
#       $input_string  $ENV{'CONTENT_LENGTH'}
read (STDIN, $input_string, $ENV{'CONTENT_LENGTH'});

#      
@input_pairS = split "&", $input_string;
#       
foreach $input_pair (@input_pairS)
 {
  #   -  
  ($name, $value) = split "=", $input_pair;
  $FORM{$name} = $value;
  #   -  
  ($key, $content) = split "=", $input_pair, 2;
  #     
  $content =~ s/\+/ /g;
  #  
  $content =~ s/%([a-fA-F--0-9][a-fA-F--0-9])/pack "C", hex($1)/eg;
  #    
  $content =~ s/\r//g;
  $FORM{$key} = $content;
 }
#-------------------------------------------------------------------------------------#
sub get_WORD
 { return unpack "v", (substr $_[0],$_[1],4); }

sub get_DWORD
 { return unpack "V", (substr $_[0],$_[1],4); }

sub get_WORD_symbols
 { return pack "v", $_[0]; }

sub get_DWORD_symbols
 { return pack "V", $_[0]; }

sub read_block
 {
  if(!-r $FORM{'file_path'}){ $stat_info .= (":  ".$FORM{'file_path'}."       !<br>"); reset_document(); };
  open FILE,$FORM{'file_path'};
  $stat_info .= ($_[1]."    ".$_[0]."<br>");
  binmode FILE;
  seek FILE,$_[0],0; read FILE,$_[2],$_[1];
  close FILE;
 }

sub reset_document
 {
  $stat_info =~ s/\x5c/\\x5c/g;
  my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";
  my $file_path_for_stat = $FORM{'file_path'}; $file_path_for_stat =~ s/\x5c/\\x5c/g;
  print <<HTML;
  <script type='text/javascript'><!--
  parent.document.getElementById('current_string_file_path').innerHTML = "$file_path_for_stat";
  parent.internal_default_status = "$file_path_for_stat";
  parent.opener.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.opener.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
  parent.opener.FLAG_no_action = 0;
  parent.opener.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.opener.get_request_time() - parent.opener.request_start_time)*Math.pow(10,parent.opener.float_precision)))/Math.pow(10,parent.opener.float_precision);
  // --></script>
HTML

  exit;
 }

sub get_date
 {
  ($day, $mn, $yr) = (localtime)[3..5];
  if($day < 10){ $day = "0$day"; };
  $mn = ($mn < 10) ? "0($mn+1)" : ($mn+1);
  if($yr < 2000){ $yr += 1900; };
  return "$day$mn$yr";
 }

sub get_time
 {
  ($sec, $min, $hour) = (localtime)[0..2];
  if($sec < 10){ $sec = "0$sec"; };
  if($min < 10){ $min = "0$min"; };
  if($hour < 10){ $hour = "0$hour"; };
  return "$hour:$min:$sec";
 }
#-----------------------------------------------------------------------#
print "content-type: text/html; charset=Windows-1251\n\n<style type='text/css'><!-- .unselected_string_number { width: 100px; padding: 2px; vertical-align: top; border: solid grey; border-width: 1px 1px 0px 1px; background-color: white; color: black; cursor: pointer; cursor: hand; } .selected_string_number { width: 100px; padding: 2px; vertical-align: top; border: solid grey; border-width: 1px 1px 0px 1px; background-color: gray; color: white; cursor: pointer; cursor: hand; } --></style>";

$stat_info .= "  ...<br> ".$FORM{'file_path'}." ...<br>";

#  
if(!-r $FORM{'file_path'}){ $stat_info .= (":  ".$FORM{'file_path'}."       !<br>"); reset_document(); };
open FILE,$FORM{'file_path'};
#     ( )
(undef, undef, undef, undef, undef, undef, undef, $file_size) = stat FILE;
#  
close FILE;

$stat_info .= ("->     ... ");
read_block(0,20,$header);
#   
$file_type = substr $header,0,4;
if($file_type ne "TLK ")
 { $stat_info .= (":   ".$FORM{'file_path'}."  !<br>"); reset_document(); };
#  
$file_version = substr $header,4,4;
if($file_version eq "V3.0")
 {
  #     
  $file_strings = (get_DWORD($header,12) - 1);
  #        
  $strings_offset = get_DWORD($header,16);
 }
elsif($file_version eq "V1  ")
 {
  $file_strings = (get_DWORD($header,10) - 1);
  $strings_offset = get_DWORD($header,14);
 }

if($file_version eq "V3.0")
 { $header_length = 20; $string_data_length = 40; }
elsif($file_version eq "V1  ")
 { $header_length = 18; $string_data_length = 26; }

$stat_info .= "->       ... ";
read_block($header_length,$strings_offset-$header_length,$strings_data_table);
$stat_info .= "->     ... ";
read_block($strings_offset,$file_size-$strings_offset,$strings_content);

#print " : ".$FORM{'file_path'}."<br>";
#print " : ".$file_type."<br>";
#print " : ".$file_version."<br>";
#print "   : ".(length $strings_data_table)."<br>";
#print "  : ".(length $strings_content)."<br>";

$stat_info .= "->   ... ";
my $output_content;
my $start_position = $FORM{'string_number'};
my $end_position = ($FORM{'string_number'} + 500 <= $file_strings) ? ($FORM{'string_number'} + 500) : $file_strings;
if($file_version eq "V3.0")
 {
  for my $n ($start_position..$end_position)
   {
    #    
    my $current_offset = get_DWORD($strings_data_table,$string_data_length*$n+28);
    #    
    my $current_length = get_DWORD($strings_data_table,$string_data_length*$n+32);
    #    
    my $current_string = substr $strings_content,$current_offset,$current_length;
    #     
    $output_content .= "<tr><td class='unselected_string_number' title='  - ,  -   .' onClick='parent.select_string(this,".$n.")' onContextMenu='this.blur(); parent.unselet_all_strings(); return false' onMouseOver='parent.internal_status_over(this)' onMouseOut='parent.internal_status_out()'>".$n."</td><td style='padding: 2px; vertical-align: top; border: solid grey; border-width: 1px 1px 0px 0px;'><textarea id='".$n."_content' style='width: 100%; height: 16px; margin: 0px; padding: 0px; border-width: 0px; font: normal 12px verdana; background-color: white; color: black; overflow: auto;' onFocus='this.style.height=\"100%\"; if(parent.opener.closed == false){ if(parent.opener.check_submit() == true){ parent.opener.request_start_time = parent.opener.get_request_time(); parent.opener.document.main_form.string_number.value = ".$n."; parent.opener.fix_current_string_number(); parent.opener.open_string(); }else{ parent.opener.document.main_form.string_number.value = ".$n."; parent.opener.fix_current_string_number(); parent.opener.show_second_string(); } }; this.focus();' onBlur='this.style.height=\"16px\";' onChange='if(parent.opener.closed == false){ parent.opener.document.main_form.string_content.value = this.value; parent.opener.string_change(); };' onMouseOver='this.title=this.innerHTML' onMouseout='this.title=\"\"'>".$current_string."</textarea></td></tr>";
   }
  }
elsif($file_version eq "V1  ")
 {
  for my $n ($start_position..$end_position)
   {
    my $current_offset = get_DWORD($strings_data_table,$string_data_length*$n+18);
    my $current_length = get_DWORD($strings_data_table,$string_data_length*$n+22);
    my $current_string = substr $strings_content,$current_offset,$current_length;
    $output_content .= "<tr><td class='unselected_string_number' title='  - ,  -   .' onClick='parent.select_string(this,".$n.")' onContextMenu='this.blur(); parent.unselet_all_strings(); return false' onMouseOver='parent.internal_status_over(this)' onMouseOut='parent.internal_status_out()'>".$n."</td><td style='padding: 2px; vertical-align: top; border: solid grey; border-width: 1px 1px 0px 0px;'><textarea id='".$n."_content' style='width: 100%; height: 16px; margin: 0px; padding: 0px; border-width: 0px; font: normal 12px verdana; background-color: white; color: black; overflow: auto;' onFocus='this.style.height=\"100%\"; if(parent.opener.closed == false){ if(parent.opener.check_submit() == true){ parent.opener.request_start_time = parent.opener.get_request_time(); parent.opener.document.main_form.string_number.value = ".$n."; parent.opener.open_string(); }else{ parent.opener.document.main_form.string_number.value = ".$n."; parent.opener.show_second_string(); } };' onBlur='this.style.height=\"16px\";' onChange='if(parent.opener.closed == false){ parent.opener.document.main_form.string_content.value = this.value; parent.opener.string_change(); };' onMouseOver='this.title=this.innerHTML' onMouseout='this.title=\"\"'>".$current_string."</textarea></td></tr>";
   }
  }

print "<table cellspacing=0px style='width: 100%; margin: 0px; border: solid grey; border-width: 0px 0px 1px 0px; font: normal 12px verdana; background: #ffffff; color: #000000;'><tr><td style='width: 100px; padding: 2px; vertical-align: top; border: solid grey; border-width: 1px 1px 0px 1px; font-weight: bold;' onContextMenu='this.blur(); return false'> </td><td style='padding: 2px; vertical-align: top; border: solid grey; border-width: 1px 1px 0px 0px; font-weight: bold;' onContextMenu='this.blur(); return false'> </td></tr>".$output_content."</table>";

$stat_info .= ($end_position - $start_position)." <br>";

reset_document();